package ontologyRelated;


import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.graph.impl.LiteralLabel;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntModelSpec;
import com.hp.hpl.jena.query.*;
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.sparql.engine.binding.Binding;
import com.hp.hpl.jena.sparql.engine.http.QueryEngineHTTP;
import com.hp.hpl.jena.sparql.core.Var;


public class ReadModel {

	public static void main(String[] args) {
		
		String fileName = "npd" ;
		String className = "<http://sws.ifi.uio.no/vocab/npd-v2#SeismicSurvey>" ;
		
	/*	String fileName = "mv" ;
		String className = "<http://myvolts.com#Tech_spec>" ; */
		
		ArrayList<ArrayList<String>> dataPropAndType = new ArrayList<ArrayList<String>>();
		dataPropAndType.add(new ArrayList<String>()); 
		dataPropAndType.add(new ArrayList<String>());

		String queryString = ""
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#> "
				+ "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> "
				+ "SELECT ?property ?range  WHERE { "
			//	+ "?property <http://www.w3.org/2000/01/rdf-schema#label> ?label . "
				+ "?property ?x <http://www.w3.org/2002/07/owl#DatatypeProperty> . "
				+ "?property <http://www.w3.org/2000/01/rdf-schema#range> ?range ."
				+ "{"
				+ "?property <http://www.w3.org/2000/01/rdf-schema#domain> "
				+ className 
				+ " . "
				+ "} "
				+ "UNION { "
				+ "?property <http://www.w3.org/2000/01/rdf-schema#domain> ?class. "
				+ "?class owl:unionOf/rdf:rest*/rdf:first " 
				+ className
				+ ". } "
				+ "} ";
		System.out.println(queryString);
		//com.hp.hpl.jena.query.Query query = QueryFactory.create(queryString);
		QueryEngineHTTP qExe = new QueryEngineHTTP("http://localhost:3030/"+ fileName + "/", queryString);
		
		//QueryExecution qExe = QueryExecutionFactory.sparqlService("http://localhost:3030/"+ fileName + "/", query);
		ResultSet results = qExe.execSelect();

		while(results.hasNext()) {
	//		System.out.println("going here");
			QuerySolution qs = results.nextSolution();
			RDFNode node = qs.get("property");
			RDFNode nodeRange = qs.get("range");

			Node resource = node.asNode();
			Node resourceRange = nodeRange.asNode();

			String label = resource.getLocalName();
			System.out.println(label);

			String labelRange = resourceRange.getLocalName();
			dataPropAndType.get(0).add(label);
			dataPropAndType.get(1).add(labelRange);
			System.out.println(label + "  " + labelRange);

		} 


	}

	public ArrayList<ArrayList<String>> getDataPropertyAndType(String fileName, String className){

		ArrayList<ArrayList<String>> dataPropAndType = new ArrayList<ArrayList<String>>();
		dataPropAndType.add(new ArrayList<String>()); 
		dataPropAndType.add(new ArrayList<String>());
		/*	String queryString = "SELECT  ?property ?x ?range  WHERE {"
				+ "?property <http://www.w3.org/2000/01/rdf-schema#Literal> ?label ."
				+ "?property ?x <http://www.w3.org/2002/07/owl#DatatypeProperty> ."
    //		+ "?property <http://www.w3.org/2000/01/rdf-schema#domain> <http://purl.org/ontology/mo/MusicArtist> ."
    		+ "?property <http://www.w3.org/2000/01/rdf-schema#range> ?range .}"; 
		 */	
	
/*		String queryString = ""
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#> "
				+ "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> "
				+ "SELECT ?label ?range  WHERE { "
				+ "?property <http://www.w3.org/2000/01/rdf-schema#label> ?label . "
				+ "?property ?x <http://www.w3.org/2002/07/owl#DatatypeProperty> . "
				+ "?property <http://www.w3.org/2000/01/rdf-schema#range> ?range ."
				+ "{"
				+ "?property <http://www.w3.org/2000/01/rdf-schema#domain> "
				+ className 
				+ " . "
				+ "} "
				+ "UNION { " */
	//			+ "?property <http://www.w3.org/2000/01/rdf-schema#domain> ?class. "
	//			+ "?class owl:unionOf/rdf:rest*/rdf:first " 
	/*			+ className
				+ ". } "
				+ "} "; 
	*/	
				
				String queryString = ""
						+ "PREFIX owl: <http://www.w3.org/2002/07/owl#> "
						+ "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> "
						+ "SELECT ?property ?range  WHERE { "
					//	+ "?property <http://www.w3.org/2000/01/rdf-schema#label> ?label . "
						+ "?property ?x <http://www.w3.org/2002/07/owl#DatatypeProperty> . "
						+ "?property <http://www.w3.org/2000/01/rdf-schema#range> ?range ."
						+ "{"
						+ "?property <http://www.w3.org/2000/01/rdf-schema#domain> "
						+ className 
						+ " . "
						+ "} "
						+ "UNION { "
						+ "?property <http://www.w3.org/2000/01/rdf-schema#domain> ?class. "
						+ "?class owl:unionOf/rdf:rest*/rdf:first " 
						+ className
						+ ". } "
						+ "} ";
	//	System.out.println(queryString);
		//com.hp.hpl.jena.query.Query query = QueryFactory.create(queryString);
		QueryEngineHTTP qExe = new QueryEngineHTTP("http://localhost:3030/"+ fileName + "/", queryString);
		
		//QueryExecution qExe = QueryExecutionFactory.sparqlService("http://localhost:3030/"+ fileName + "/", query);
		ResultSet results = qExe.execSelect();

		while(results.hasNext()) {
			
			QuerySolution qs = results.nextSolution();
		//	RDFNode node = qs.get("label");
			RDFNode node = qs.get("property");
			RDFNode nodeRange = qs.get("range");

			Node resource = node.asNode();
			Node resourceRange = nodeRange.asNode();

		
			//use below for (2) label extraction using label
			//	LiteralLabel label = resource.getLiteral();
			
			//use below for (1) label extraction using fragment ID
			String label = resource.getLocalName();
			
			String labelRange = resourceRange.getLocalName();
			
			//use below for (1) label extraction using fragment ID
		//	dataPropAndType.get(0).add(label.getLexicalForm());
			
			//use below for (2) label extraction using label
			dataPropAndType.get(0).add(label);
			
			
			
			dataPropAndType.get(1).add(labelRange);
		//	System.out.println(label + "  " + labelRange);
		}
		return dataPropAndType;
	}
}