package tableClass;

import java.util.ArrayList;
import java.util.LinkedList;

import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.query.QuerySolution;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.sparql.engine.http.QueryEngineHTTP;

public class readOntologySchema {


	public static void main(String[] args) {
		String fileName = "CMT";
		ArrayList<ArrayList<String>> classes = ontologyClasses(fileName);
		System.out.println(classes.get(0));
		ArrayList<String> props = getProperties(fileName, classes.get(0).get(2));
		System.out.println(props);
	}


	public static ArrayList<ArrayList<String>> ontologyClasses(String fileName){
		ArrayList<ArrayList<String>> onto = new  ArrayList<>();
		onto.add(new  ArrayList<String>()); 
		onto.add(new  ArrayList<String>()); 
		String queryString = ""
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#> "
				+ "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> "
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> "
				+ "SELECT distinct ?class  WHERE { "
				+ "?class a owl:Class . "
				+ "FILTER(isURI(?class))"
			//	+ "?prop rdfs:domain ?class ."
				+ "} ";

		System.out.println(queryString);
		QueryEngineHTTP qExe = new QueryEngineHTTP("http://localhost:3030/"+ fileName + "/", queryString);

		ResultSet results = qExe.execSelect();

		while(results.hasNext()) {

			QuerySolution qs = results.nextSolution();
			//	RDFNode node = qs.get("label");
			RDFNode node = qs.get("class");
			Node resource = node.asNode();
			//	LiteralLabel label = resource.getLiteral();
			String label = resource.getLocalName();
			String URI = node.toString();
			//		System.out.println(URI);
			onto.get(0).add(URI);
			onto.get(1).add(label);

		}
		return onto;
	}

	public static ArrayList<String> getProperties(String fileName, String classURI){
		ArrayList<String> classProperties = new ArrayList<>();
		String queryString = ""
				+ "PREFIX owl: <http://www.w3.org/2002/07/owl#> "
				+ "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> "
				+ "PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>"
				+ "SELECT distinct ?property  WHERE { "
				+ "?property rdfs:domain <"
				+ classURI
				+ "> ."
				+ "?property a ?y ."
				+ "FIlTER (?y = owl:DatatypeProperty || ?y = owl:ObjectProperty)"
				+ "} ";

			System.out.println(queryString);
		QueryEngineHTTP qExe = new QueryEngineHTTP("http://localhost:3030/"+ fileName + "/", queryString);

		ResultSet results = qExe.execSelect();
		while(results.hasNext()) {

			QuerySolution qs = results.nextSolution();
			//	RDFNode node = qs.get("label");
			RDFNode node = qs.get("property");
			Node resource = node.asNode();
			//	LiteralLabel label = resource.getLiteral();
			String label = resource.getLocalName();
			classProperties.add(label);
			//		System.out.println(label);
		}
		return classProperties;
	} 

}
