library(sqldf);
library(fuzzywuzzyR);
library(clue);
setwd("~/Documents/workspace/AutomatiqMapping");

classTable <- read.csv("class-table_thresh70.csv", header = FALSE);
classTable <- classTable[,c(1,2)]


rdf <- read.csv(file = "sparql_ObjectProperty.csv");
rdf <- as.data.frame(apply(rdf,2,function(x)gsub('\\s+', '',x)));


rdb <- read.csv("rdb_relationship.csv", sep = ",");
rdb <- as.data.frame(apply(rdb,2,function(x)gsub('\\s+', '',x)));

a <- sqldf("select distinct domain, range from rdf")


a_rdb <- unique(rdb[,c('table','table_second')])
#b_rdb <- rdb[rdb$table == a_rdb$table[2], ];
#b_rdb <- b_rdb[b_rdb$table_second == a_rdb$table_second[2], ]


names(classTable)[names(classTable)=="V2"] <- "domain"
breakup <- merge(a, classTable, by = c("domain"), all.x = TRUE)

names(classTable)[names(classTable)=="domain"] <- "range"
breakup <- merge(breakup, classTable, by = c("range"), all.x = TRUE)
breakup <- breakup[,c(3,4)];
names(breakup) <- c("table", "table_second");
total <- unique(rbind(a_rdb, breakup));

for(i in 1:43){
   i = 1;
  
  b_rdb <- rdb[rdb$table == toString(total$table[i]), ];
  b_rdb <- b_rdb[b_rdb$table_second == toString(a_rdb$table_second[i]), ];
  
  x <- toString(classTable[classTable$V1 == toString(total$table[i]),2 ]);
  y <- toString(classTable[classTable$V1 == toString(total$table_second[i]),2 ]);
  
  b <- rdf[rdf$domain == x, ];
  b <- b[b$range == y,];
  
  if(length(b$property) > 0 && length(b_rdb$table) > 0){
    mat <- matrix(nrow = length(b_rdb$table), ncol = length(b$property));
    print(c(trimws(toString(total$table[i])), "&",trimws(toString(total$table_second[i]))));
    for(rdb_con in 1: length(b_rdb$table)){
      #  rdb_con = 1;
      for(rdf_con in 1: length(b$property)){
        #   rdf_con = 1;
        init = FuzzMatcher$new();
        s1 = toString(b$property[rdf_con]);
        s2 = toString(b_rdb$FK_Column_Name[rdb_con]);
        temp <- as.integer(init$Partial_token_set_ratio(string1 = s1, string2 = s2, force_ascii = TRUE, full_process = TRUE));
        mat[rdb_con,rdf_con] <- temp;
        
        # if(temp >= 70) {
        #  print(c(s1,s2,temp,toString(b_rdb$Type[rdb_con])));
        # }
      }
      
    }
   
     if(length(b$property) > length(b_rdb$table)){
      
      sahilMathur <- solve_LSAP(mat, maximum = TRUE);
      for(lsap_1 in 1:length(b_rdb$table)){
        print(c(toString(b$property[sahilMathur[lsap_1]]), toString(b_rdb$FK_Column_Name[lsap_1]), toString(b_rdb$Type[lsap_1]),mat[lsap_1, sahilMathur[lsap_1]]));
      }
      #print(sahilMathur[1]);
     
    }
    else{
      sahilMathur <- solve_LSAP(t(mat), maximum = TRUE);
      for(lsap_2 in 1:length(b$property)){
        print(c(toString(b$property[lsap_2]), toString(b_rdb$FK_Column_Name[sahilMathur[lsap_2]]), toString(b_rdb$Type[sahilMathur[lsap_2]]),mat[sahilMathur[lsap_2],lsap_2]));
      }
      #print(c(s1,s2,temp,toString(b_rdb$Type[rdb_con])));
    }
  
    
    
    }
  
  
  
}


